import org.codehaus.jackson.map.ObjectMapper;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.apache.commons.httpclient.util.URIUtil;
import java.io.*;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;

/**
 * Created by magnus on 25.09.15.
 *
 * This program connects to the AsterixDB instance and performs the test queries. 
 * This is to give a basic idea on how to interact with the AsterixDB HTTP API.
 *
 */
public class Main{

    private static double maxLat= 10.41207;
    private static double minLat= 10.39836;
    private static double maxLong= 63.42080;
    private static double minLong= 63.41242;

    public static void main (String [] args){

        Main main = new Main();
        main.init();
    }
    public void init(){
        String dataset = "posdata3";
        long startTime = 1412121600;
        long endTime1 = 1412208000;
        long endTime7 = 1412726400;
        long endTime30 = 1414800000;

        String queryCountRecords = "query=use dataverse bigd;count(for $obj in dataset "+dataset+" return $obj);";
        String queryRaw1 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" return $obj)";
        String queryRaw2 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" and $obj.hourOfDay >= 9 and $obj.hourOfDay <= 15 return $obj)";
        String queryRaw3 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" and $obj.hourOfDay > 9 and $obj.hourOfDay < 15 and ($obj.dayOfWeek = 1 or $obj.dayOfWeek = 3) return $obj)";
        String queryRaw4 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" and $obj.hourOfDay > 9 and $obj.hourOfDay < 15 and $obj.building = 'IT-Vest' return $obj)";
        String queryRaw5 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" and $obj.accuracy < 10 return $obj)";
        String queryRaw6 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" and $obj.id = '10' return $obj)";
        String queryRaw7 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" and $obj.hourOfDay > 9 and $obj.hourOfDay < 15 and ($obj.dayOfWeek = 1 or $obj.dayOfWeek = 3) and $obj.building = 'Realfagbygget' and $obj.floor = '4. etasje' return $obj)";
        String queryRaw8 = "query=use dataverse bigd;count(from $obj in dataset "+dataset+" where $obj.timestamp >= "+startTime+" and $obj.timestamp <= "+endTime1+" and $obj.building = 'Realfagbygget' return $obj)";

        query(queryRaw1);
        query(queryRaw2);
        query(queryRaw3);
        query(queryRaw4);
        query(queryRaw5);
        query(queryRaw6);
        query(queryRaw7);
        query(queryRaw8);
    }
    private void query(String queryRaw){
        Long s = System.nanoTime();
        try {
            String charset = java.nio.charset.StandardCharsets.UTF_8.name();  // Or in Java 7 and later, use the constant:

            String encoded = URIUtil.encodeQuery(queryRaw);
            encoded.replace("'","%27");

            String url = "http://129.241.106.23:19002/query";
            URLConnection connection = new URL(url+"?"+encoded).openConnection();
            connection.setRequestProperty("Accept-Charset", charset);
            InputStream inputStream = connection.getInputStream();
            JSONParser jsonParser = new JSONParser();
            JSONObject jsonObject = (JSONObject)jsonParser.parse(new InputStreamReader(inputStream,"UTF-8"));
            inputStream.close();
            System.out.println(jsonObject.toString());

            long e = System.nanoTime();
            long time = (e-s)/1000000;
            /**** Done ****/
            System.out.println("--------------------------------------------------");
            System.out.println("Done in "+time+" ms");

            inputStream.close();
        }catch (Exception e){
            System.out.println(e);
        }
    }
}
