function AppViewModel() {
}
ko.applyBindings(new AppViewModel());
var map, heatmap;

function soek(){
    if(heatmap){
        heatmap.setMap(null);
    }
    getData(); //use this function to decompress Matrix V1
    //getData2(); //use this function to decompress Matrix V2
}

function initMap() {
  map = new google.maps.Map(document.getElementById('map'), {
    zoom: 15,

    center: {lat: 63.417044, lng: 10.404911},
    mapTypeId: google.maps.MapTypeId.MAP
  });
}
function toggleHeatmap() {
  heatmap.setMap(heatmap.getMap() ? null : map);
}
function changeGradient() {
  var gradient = [
    'rgba(0, 255, 255, 0)',
    'rgba(0, 255, 255, 1)',
    'rgba(0, 191, 255, 1)',
    'rgba(0, 127, 255, 1)',
    'rgba(0, 63, 255, 1)',
    'rgba(0, 0, 255, 1)',
    'rgba(0, 0, 223, 1)',
    'rgba(0, 0, 191, 1)',
    'rgba(0, 0, 159, 1)',
    'rgba(0, 0, 127, 1)',
    'rgba(63, 0, 91, 1)',
    'rgba(127, 0, 63, 1)',
    'rgba(191, 0, 31, 1)',
    'rgba(255, 0, 0, 1)'
  ]
  heatmap.set('gradient', heatmap.get('gradient') ? null : gradient);
}
function changeRadius() {
  heatmap.set('radius', heatmap.get('radius') ? null : 10);
}
function changeOpacity() {
  heatmap.set('opacity', heatmap.get('opacity') ? null : 0.2);
}
function getData(){
    var div = document.getElementById("map");
    console.log("START!");
    $.get('getWithParameters',
        {   from:this.fromDate.value,
            to:this.toDate.value,
            accuracy:this.accuracy.value
        }, function(data) {
        }).done(function(data){
            var list = [];
            console.log(data);
            console.log("start");

            var colSize = data.m;
            var rowSize = data.n;
            var val = JSON.parse(data.val);
            var col_idx = JSON.parse(data.col);
            var row_ptr = JSON.parse(data.row);
            var maxLat = JSON.parse(data.maxLat);
            var maxLong = JSON.parse(data.maxLong);
            var minLat= JSON.parse(data.minLat);
            var minLong= JSON.parse(data.minLong);

            var i,k,j, zeroIndex;
            for(i=0; i<rowSize;i++){
                zeroIndex=0;
                for(k=row_ptr[i]; k<row_ptr[i+1];k++){
                    j = col_idx[k];
                    var minLongCoo = (maxLong*100000);
                    var minLatCoo =  (maxLat *100000);
                    while(zeroIndex < j){
                        zeroIndex++;
                    }
                    for(var l=val[k]; l>0;l--){
                        minLongCoo-=zeroIndex;
                        minLatCoo-=i;
                        var tempLong = (minLongCoo/100000);
                        var tempLat = (minLatCoo/100000);
                        //Extra test to avoid out of bounds
                        if (tempLat>maxLat || tempLat<minLat || tempLong>maxLong || tempLong<minLong){
                        }else{
                            list.push(getLatLongObject(tempLat, tempLong));
                        }
                    }
                    zeroIndex++;
                }
                while(zeroIndex < rowSize){
                    zeroIndex++;
                }
            }
            heatmap = new google.maps.visualization.HeatmapLayer({
                data: list,
                map: map,
            });
            console.log("DONE!");
        });
}
function getData2(){
    var div = document.getElementById("map");
    console.log("START!");
    $.get('getWithParameters',
        {   from:this.fromDate.value,
            to:this.toDate.value,
            accuracy:this.accuracy.value
        }, function(data) {
        }).done(function(data){
            var list = [];

            var colSize = data.m;
            var rowSize = data.n;
            var val = JSON.parse(data.val);
            var col_idx = JSON.parse(data.col);
            var row_ptr = JSON.parse(data.row);
            var maxLat = JSON.parse(data.maxLat);
            var maxLong = JSON.parse(data.maxLong);
            var minLat= JSON.parse(data.minLat);
            var minLong= JSON.parse(data.minLong);
            var maxLong2 = maxLong* 100000;
            var maxLat2 = maxLat* 100000;
            var minLong2 = minLong* 100000;
            var minLat2 = minLat* 100000;
            var longByMatrixRange = (maxLong2-minLong2)/colSize;
            var latByMatrixRange = (maxLat2-minLat2)/rowSize;
            var i,k,j, zeroIndex;
            for(i=0; i<rowSize;i++){
                zeroIndex=0;
                for(k=row_ptr[i]; k<row_ptr[i+1];k++){
                    j = col_idx[k];
                    var minLongCoo = maxLong2;
                    var minLatCoo =  maxLat2;
                    while(zeroIndex < j){
                        zeroIndex++;
                    }
                    for(var l=val[k]; l>0;l--){
                        minLatCoo -= (zeroIndex*latByMatrixRange);
                        minLongCoo  -= (i*longByMatrixRange);
                        var tempLong = (minLongCoo/100000);
                        var tempLat = (minLatCoo/100000);
                        //Extra test to avoid out of bounds
                        if (tempLat>maxLat || tempLat<minLat || tempLong>maxLong || tempLong<minLong){
                        }else{
                            list.push(getLatLongObject(tempLat, tempLong));
                        }
                    }
                    zeroIndex++;
                }
                while(zeroIndex < rowSize){
                    zeroIndex++;
                }
            }
            heatmap = new google.maps.visualization.HeatmapLayer({
                data: list,
                map: map,
            });
            console.log("DONE!");
        });
}
function getLatLongObject(lat, long){
    return new google.maps.LatLng(lat, long);
}